class MAIN
creation make
feature
    t0, t1, t2 : BASIC_TIME
    time_limit : INTEGER
    enough : INTEGER is 10

    enough_time : BOOLEAN is
    do
	t2.update
	Result := t0.elapsed_seconds(t2) > time_limit + enough
    end

    make is
    local
	sml : SML
	cluster : CLUSTER
	done : BOOLEAN
	ignore : BOOLEAN
    do
	t0.update
	if argument_count < 1 then
	    time_limit := 180
	else
	    time_limit := argument(1).to_integer
	end
	!!sml.make
--std_error.put_string("reading...")
	sml.read
	cluster := decompose(sml)
	sml := Void
	from
	until done
	loop
	    t1.update
	    cluster.clear_change_flag
--std_error.put_string("merging...")
	    ignore := cluster.merge_optimize
	    --std_error.put_string("hope there will be no lines%N")
	    --cluster.absorb_optimize
	    --std_error.put_string("hope there was no lines%N")
--std_error.put_string("renesting...")
	    cluster.renest_optimize
--std_error.put_string("oi...")
	    cluster.overlap_invert_optimize
--std_error.put_string("color nest...")
	    cluster.color_nest_optimize
--std_error.put_string("size nest...")
	    cluster.size_nest_optimize
--std_error.put_string("emsem...")
	    cluster.emsem_optimize
--std_error.put_string("pl...")
	    cluster.pl_shortcut_optimize
	    t2.update
	    if not cluster.change_flag
		    or else t1.elapsed_seconds(t2)
		    + t0.elapsed_seconds(t2) + enough > time_limit then
		done := true
	    end
	    --std_error.put_string("bad_children: ")
	    --std_error.put_integer(cluster.bad_child_count)
	    --std_error.put_new_line
	    --std_error.put_string("empty_count: ")
	    --std_error.put_integer(cluster.empty_count)
	    --std_error.put_new_line
    --std_error.put_string("last opt. time: ")
    --std_error.put_integer(t1.elapsed_seconds(t2))
    --std_error.put_new_line
	end
	cluster.output
--std_error.put_string("total time: ")
--std_error.put_integer(t0.elapsed_seconds(t2))
--std_error.put_new_line
    end

    decompose(sml : SML) : CLUSTER is
    local
	d : DECOMPOSE
    do
	!!d.make
	Result := d.decompose(sml)
    end

end
